// rta: Pallos Pter
// 2006.11.15

#include <stdio.h>
#include <stdlib.h>

typedef struct elem {
	int key;  // ez alapjn rendeznk
	struct elem *next;
} elem;
typedef elem* list;

// beszr egy elemet a lista elejre
list add_first(list l, int key) {
	elem *e = (elem*)malloc(sizeof(elem));
	e->key = key;
	e->next = l;
	return e;
}

// beszr egy elemet a lista vgre
list add_last(list l, int key) {
	elem *i, *e=(elem*)malloc(sizeof(elem));
	e->key = key;
	e->next = NULL;
	if (!l) return e;
	else {
		for (i=l; i->next; i=i->next);
		i->next = e;
		return l;
	}
}

// beszr egy elemet egy rendezett listba, a rendezettsget fenntartva
list add_sorted(list l, int key) {
	elem *i, *prev=NULL, *e=(elem*)malloc(sizeof(elem));
	for (i=l; i && i->key < key; i=i->next) prev=i;
	e->key = key;
	e->next = i;
	if (prev) prev->next = e;
	return prev ? l : e;
}

// beszr egy elemet az index pozcira. 0 <= index <= lista mrete
list add_index(list l, unsigned index, int key) {
	elem *i, *e=(elem*)malloc(sizeof(elem));
	e->key = key;
	if (index && l) {
		for (i=l; i->next && --index; i=i->next) ;
		e->next = i->next;
		i->next = e;
		return l;
	} else {
		e->next = l;
		return e;
	}
}

// trli a lista els elemt
list remove_first(list l) {
	elem *e = l ? l->next : NULL;
	if (!l) return NULL;  // eleve res
	free(l);
	return e;
}

// trli a lista utols elemt
list remove_last(list l) {
	elem *i, *prev=NULL;
	if (!l) return NULL;  // eleve res
	for (i=l; i->next; i=i->next) prev=i;
	free(i);
	if (prev) prev->next=NULL;
	return prev ? l : NULL;
}

// trli a lista adott kulcs elemt
list remove_key(list l, int key) {
	elem *i, *prev=NULL;
	for (i=l; i && i->key!=key; i=i->next) prev=i;
	if (i) {
		if (prev) prev->next = i->next; else l=l->next;
		free(i);
	}
	return l;
}

// trli a lista sszes elemt
void clear(list l) {
	while (l) {
		elem *e = l->next;
		free(l);
		l = e;
	}
}

// megfordtja a listt
list reverse(list l) {
	elem *i, *next, *first=NULL;
	for (i=l; i; i=next) {
		next = i->next;
		i->next = first;
		first = i;
	}
	return first;
}

// nvekv sorrendbe rendezi a listt
list sort_list(list l) {
	list nl=NULL;
	elem *e, *i, *prev, *next;
	for (e=l; e; e=next) {
		next = e->next;
		prev = NULL;
		for (i=nl; i && i->key < e->key; i=i->next) prev=i;
		e->next = i;
		if (prev) prev->next = e;
		nl = prev ? nl : e;
	}
	return nl;
}

// kirja a lista elemeit
void print_list(list l) {
	elem *i;
	for (i=l; i!=NULL; i=i->next)
		printf("%d%c", i->key, i->next?' ':'\n');
}

int main() {
	list l = NULL;

	l=add_first(l,3);
	l=add_last(l,1);
	l=sort_list(l);
	print_list(l);  // 1 3

	l=add_sorted(l,2);
	print_list(l);  // 1 2 3

	l=add_index(l,2,4);
	print_list(l);  // 1 2 4 3

	l=reverse(l);
	print_list(l);  // 3 4 2 1

	l=remove_key(l,2);
	print_list(l);  // 3 4 1

	l=remove_first(l);
	print_list(l);  // 4 1

	clear(l);
}